/*
** Destop's player plugin
** Copyright (c) 2003 Destop - CZN
**
*/

#include <windows.h>
#include <mmreg.h>
#include <msacm.h>
#include <math.h>
#include "in2.h"
#include "dspadpcm.h"

#ifdef _DEBUG

void __cdecl DisplayError (char * Message, ...) {
	char Msg[400];
	va_list ap;

	va_start( ap, Message );
	vsprintf( Msg, Message, ap );
	va_end( ap );
	MessageBox(NULL,Msg,"Error",MB_OK|MB_ICONERROR|MB_SETFOREGROUND);
}
#else
void __cdecl DisplayError (char * Message, ...) {}
#endif

void fillinterleavebuffer(void);

// avoid CRT. Evil. Big. Bloated.
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

// post this to the main window at end of file (after playback as stopped)
#define WM_WA_MPEG_EOF WM_USER+2
// raw configuration
#define BPS 16

int interleavebytes;
int interleavesamples;

#define looptimes 2
#define masterfadelength 10
#define type_std 0
#define type_sfass 1
#define type_mp2 2

char lastfn[MAX_PATH]; // currently playing file (used for getting info on the current file)
char sample_buffer[576*2*2]; // sample buffer
char ADPCMbuf[8]; // buffer for current ADPCM frame

// largest interleave (so far) is 0x8f00 bytes for Metroid Prime 2
short interleave1[0x8f00/8*14]; // buffer for interleaved channel 1
short interleave2[0x8f00/8*14]; // " " 2
int interleavereadpos,interleavebufsize;

int file_length; // file length, in bytes
double decode_pos_ms; // current decoding position, in milliseconds
int paused; // are we paused?
int seek_needed; // if != -1, it is the point that the decode thread should seek to, in ms.
int killDecodeThread=0;				// the kill switch for the decode thread
int NCH = 2;
int SAMPLERATE = 44100;
double fadecount;
int headertype,loopcount;
sDSPADPCM dsp,dsp2;
short hist11, hist12; // for channel 1
short hist21, hist22; // for channel 2
int headersize;

In_Module mod; // the output module (declared near the bottom of this file)

HANDLE input_file=INVALID_HANDLE_VALUE; // input file handle
HANDLE thread_handle=INVALID_HANDLE_VALUE;	// the handle to the decode thread

DWORD WINAPI __stdcall DecodeThread(void *b); // the decode thread procedure

void config(HWND hwndParent)
{
	MessageBox(hwndParent,
		"No configuration.",
		"Configuration",MB_OK);
	// if we had a configuration we'd want to write it here :)
}

void about(HWND hwndParent)
{
	MessageBox(hwndParent,"Destop's DSP Player.\n\n For Playing NGC DSP files\n\n Destop-CZN (c) 2003\n\nv1.3 Modified by hcs","Destop's DSP Player",MB_OK);
}

void init() { /* any one-time initialization goes here (configuration reading, etc) */ 
}

void quit() { /* one-time deinit, such as memory freeing */ 
}

int isourfile(char *fn) { return 0; } 
// used for detecting URL streams.. unused here. strncmp(fn,"http://",7) to detect HTTP streams, etc


int get16bit(unsigned char* p)
{
	return (p[0] << 8) | p[1];
}

int get32bit(unsigned char* p)
{
	return (p[0] << 24) | (p[1] << 16) | (p[2] << 8) | p[3];
}


int nrsamples;

// standard devkit version
void get_dspheaderstd(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf);
	dsp->num_adpcm_nibbles=get32bit(buf+4);
	dsp->sample_rate=get32bit(buf+8);
	dsp->loop_flag=get16bit(buf+0xC);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=get32bit(buf+0x10);
	dsp->ea=get32bit(buf+0x14);
	dsp->ca=get32bit(buf+0x18);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x1C+i*2);
	dsp->gain=get16bit(buf+0x3C);
	dsp->ps=get16bit(buf+0x3E);
	dsp->yn1=get16bit(buf+0x40);
	dsp->yn2=get16bit(buf+0x42);
	dsp->lps=get16bit(buf+0x44);
	dsp->lyn1=get16bit(buf+0x46);
	dsp->lyn2=get16bit(buf+0x48);
	for(i=0;i<11;i++)
	dsp->pad[i]=get16bit(buf+0x4A+i*2);
}

// SF Assault version
void get_dspheadersfa(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	buf+=0x20; // for SF Assault
	dsp->num_samples=get32bit(buf);
	dsp->num_adpcm_nibbles=get32bit(buf+4);
	dsp->sample_rate=get32bit(buf+8);
	dsp->loop_flag=get16bit(buf+0xC);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=get32bit(buf+0x10)*2;
	dsp->ea=get32bit(buf+0x14);
	dsp->ca=get32bit(buf+0x18);
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x1C+i*2);
	dsp->gain=get16bit(buf+0x3C);
	dsp->ps=get16bit(buf+0x3E);
	dsp->yn1=get16bit(buf+0x40);
	dsp->yn2=get16bit(buf+0x42);
	dsp->lps=get16bit(buf+0x44);
	dsp->lyn1=get16bit(buf+0x46);
	dsp->lyn2=get16bit(buf+0x48);
	for(i=0;i<11;i++)
	dsp->pad[i]=get16bit(buf+0x4A+i*2);
	//DisplayError("yn1=%08x\nyn2=%08x",dsp->yn1,dsp->yn2);
}

// Metroid Prime 2 version
void get_dspheadermp2(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf+0x8);
	dsp->num_adpcm_nibbles=get32bit(buf+0x10);
	dsp->sample_rate=get32bit(buf+0x0c);
	dsp->loop_flag=get16bit(buf+0x14);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=get32bit(buf+0x18)*2;
	dsp->ea=get32bit(buf+0x1c)*2;
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x20+i*2);
	dsp->yn1=dsp->yn2=dsp->lyn1=dsp->lyn2=0;
}

// Metroid Prime 2 version (second channel)
void get_dspheadermp22(sDSPADPCM *dsp,unsigned char *buf)
{
	int i;
	dsp->num_samples=get32bit(buf+0x8);
	dsp->num_adpcm_nibbles=get32bit(buf+0x10);
	dsp->sample_rate=get32bit(buf+0x0c);
	dsp->loop_flag=get16bit(buf+0x14);
	dsp->format=get16bit(buf+0xE);
	dsp->sa=get32bit(buf+0x18)*2;
	dsp->ea=get32bit(buf+0x1c)*2;
	DisplayError("get_dspheader:\nnum_samples=%li\nnum_adpcm_nibbles=%li\nsample_rate=%li\n"
		"loop_flag=%04x\nformat=%04x\nsa=%08x\nea=%08x\nca=%08x",dsp->num_samples,dsp->num_adpcm_nibbles,
		dsp->sample_rate,dsp->loop_flag,dsp->format,dsp->sa,dsp->ea,dsp->ca);
	for (i=0;i<16;i++)
	dsp->coef[i]=get16bit(buf+0x40+i*2);
	dsp->yn1=dsp->yn2=dsp->lyn1=dsp->lyn2=0;
}

void ReadDSPHeader(HANDLE infile, sDSPADPCM *dsp, sDSPADPCM * dsp2, int * NCH,
				   int * interleavebytes, int * headersize, int * headertype) {
	unsigned char readbuf[0xe0];
	int l;

	SetFilePointer(infile,0,0,FILE_BEGIN);

	ReadFile(infile, &readbuf, 0xe0, &l, NULL);
	
	if (readbuf[0]=='R' && readbuf[1]=='S' && readbuf[2]==0x00 && readbuf[3]==0x03) {
		get_dspheadermp2(dsp,readbuf);
		get_dspheadermp22(dsp2,readbuf);
		*NCH=2;
		*interleavebytes=0x8f00;
		*headersize=0x60;		
		*headertype=type_mp2;
	} else if (readbuf[0]=='C' && readbuf[1]=='s' && readbuf[2]=='t' && readbuf[3]=='r') {
		get_dspheadersfa(dsp,readbuf);
		get_dspheadersfa(dsp2,readbuf+0x60);
		*NCH=2;
		*interleavebytes=0x800;
		*headersize=0xe0;
		*headertype=type_sfass;
	} else {
		// assume standard devkit
		get_dspheaderstd(dsp,readbuf);
		get_dspheaderstd(dsp2,readbuf+0x60); // header for channel 2 (duh!)

		// if a valid second header (agrees with first)
		if (dsp->num_adpcm_nibbles==dsp2->num_adpcm_nibbles &&
			dsp->num_samples==dsp2->num_samples) {
			// stereo
			*NCH=2;
			*interleavebytes=0x8000;
			*headersize=0xc0;
			*headertype=type_std;
		} else {
			// mono
			*NCH=1;
			*interleavebytes=0x10;
			*headersize=0x60;
			*headertype=type_std;
		}
	}
}

int play(char *fn) 
{ 
	int maxlatency;
	int thread_id;
	static int doonce=0;
	static int first_alloc_size=0x3000000;

	input_file = CreateFile(fn,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);

	if (input_file == INVALID_HANDLE_VALUE) // error opening file
	{
		return 1;
	}

	ReadDSPHeader(input_file,&dsp,&dsp2,&NCH,&interleavebytes,&headersize,&headertype);

	SetFilePointer(input_file, headersize, NULL, FILE_BEGIN);

	interleavesamples=(interleavebytes/8*14);

	SAMPLERATE = dsp.sample_rate;
	if (!dsp.loop_flag) nrsamples = dsp.num_samples;
	else nrsamples = (dsp.sa+looptimes*(dsp.ea-dsp.sa))*14/8/2+masterfadelength*SAMPLERATE;

	if (dsp.loop_flag) loopcount=looptimes;
	else loopcount=0;
	
    file_length=GetFileSize(input_file,NULL);

	hist11=dsp.yn1;hist12=dsp.yn2;
	hist21=dsp2.yn1;hist22=dsp2.yn2;
	
	fadecount=-1;
	
	lstrcpy(lastfn,fn);
	paused=0;
	decode_pos_ms=0;
	seek_needed=-1;

	fillinterleavebuffer(); // start off with full buffer(s)
	
	maxlatency = mod.outMod->Open(SAMPLERATE,NCH,BPS, -1,-1);
	if (maxlatency < 0) // error opening device
	{
		MessageBox(NULL, "error opening device", "DSP error", MB_OK);
		return 1;
	}
	// dividing by 1000 for the first parameter of setinfo makes it
	// display 'H'... for hundred.. i.e. 14H Kbps.
	mod.SetInfo((SAMPLERATE*BPS*NCH*18/64)/1000,SAMPLERATE/1000,NCH,1);

	// initialize vis stuff
	mod.SAVSAInit(maxlatency,SAMPLERATE);
	mod.VSASetInfo(NCH,SAMPLERATE);

	mod.outMod->SetVolume(-666); // set the output plug-ins default volume

	killDecodeThread=0;
	thread_handle = (HANDLE) CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) DecodeThread,(void *) &killDecodeThread,0,&thread_id);
	
	return 0; 
}


void pause() 
{ 
	paused=1; 
	mod.outMod->Pause(1); 
}


void unpause() 
{ 
	paused=0; 
	mod.outMod->Pause(0); 
}


int ispaused() 
{ 
	return paused; 
}


void stop() 
{ 
	if (thread_handle != INVALID_HANDLE_VALUE)
	{
		killDecodeThread=1;
		if (WaitForSingleObject(thread_handle,INFINITE) == WAIT_TIMEOUT)
		{
			MessageBox(mod.hMainWindow,"error asking thread to die!\n","error killing decode thread",0);
			TerminateThread(thread_handle,0);
		}
		CloseHandle(thread_handle);
		thread_handle = INVALID_HANDLE_VALUE;
	}
	if (input_file != INVALID_HANDLE_VALUE)
	{
		CloseHandle(input_file);
		input_file=INVALID_HANDLE_VALUE;
	}

	mod.outMod->Close();
	mod.SAVSADeInit();
}


int getlength() 
{ 
	return nrsamples/SAMPLERATE*1000;
}


int getoutputtime() 
{ 
	return mod.outMod->GetOutputTime();
}


void setoutputtime(int time_in_ms) 
{ 
	seek_needed=time_in_ms; 
}


void setvolume(int volume) 
{ 
	mod.outMod->SetVolume(volume); 
}


void setpan(int pan) 
{ 
	mod.outMod->SetPan(pan); 
}


int infoDlg(char *fn, HWND hwnd)
{
	sDSPADPCM iddsp,iddsp2;
	int idNCH,idinterleavebytes,idheadersize,idheadertype;
	long length;
	char msgbuf[512],loopstr[50]="no loop";
	HANDLE hFile;

	hFile = CreateFile(fn,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile != INVALID_HANDLE_VALUE)
	{

		ReadDSPHeader(hFile,&iddsp,&iddsp2,&idNCH,&idinterleavebytes,&idheadersize,&idheadertype);

		// these are only second-accurate, but how accurate does this need to be anyway?
		if (!iddsp.loop_flag) length = iddsp.num_samples/iddsp.sample_rate*1000;
		else length=((iddsp.sa+looptimes*(iddsp.ea-iddsp.sa))*14/8/2/iddsp.sample_rate+masterfadelength)*1000;

		if (iddsp.loop_flag) 
			sprintf(loopstr,"loop start: 0x%04x\nloop end: 0x%04x",iddsp.sa,iddsp.ea);

		sprintf(msgbuf,"%d Hz %s DSP\n%s header type\n%d samples\n%s",iddsp.sample_rate,
			(idNCH==2?"stereo":"mono"),(idheadertype==type_std?"devkit or unrecognized":(idheadertype==type_mp2?"Metroid Prime 2":"Star Fox Assault")),
			iddsp.num_samples,loopstr
			);

		MessageBox(mod.hMainWindow,msgbuf,"DSP Info",MB_OK);
	}
	CloseHandle(hFile);

	return 0;
}

void getfileinfo(char *filename, char *title, int *length_in_ms)
{
	sDSPADPCM fidsp,fidsp2;
	int fiNCH,fiinterleavebytes,fiheadersize,fiheadertype;

	if (!filename || !*filename)  // currently playing file
	{
		if (length_in_ms) *length_in_ms=getlength();
		if (title) 
		{
			char *p=lastfn+lstrlen(lastfn);
			while (*p != '\\' && p >= lastfn) p--;
			lstrcpy(title,++p);
		}
	}
	else // some other file
	{
		if (length_in_ms) 
		{
			HANDLE hFile;
			*length_in_ms=-1000;
			hFile = CreateFile(filename,GENERIC_READ,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,
				OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
			if (hFile != INVALID_HANDLE_VALUE)
			{

				ReadDSPHeader(hFile,&fidsp,&fidsp2,&fiNCH,&fiinterleavebytes,&fiheadersize,&fiheadertype);

				// these are only second-accurate, but how accurate does this need to be anyway?
				if (!fidsp.loop_flag) *length_in_ms = fidsp.num_samples/fidsp.sample_rate*1000;
				else *length_in_ms=((fidsp.sa+looptimes*(fidsp.ea-fidsp.sa))*14/8/2/fidsp.sample_rate+masterfadelength)*1000;
			}
			CloseHandle(hFile);
		}
		if (title) 
		{
			char *p=filename+lstrlen(filename);
			while (*p != '\\' && p >= filename) p--;
			lstrcpy(title,++p);
		}
	}
}


void eq_set(int on, char data[10], int preamp) 
{ 
	// most plug-ins can't even do an EQ anyhow.. I'm working on writing
	// a generic PCM EQ, but it looks like it'll be a little too CPU 
	// consuming to be useful :)
}


#define BASEVOL 0x2000

void fillinterleavebuffer(void) {

	int i,j,l;
	long offset=SetFilePointer(input_file,0,0,FILE_CURRENT)-headersize;

	i=offset%(interleavebytes*NCH);
	if (i>interleavebytes) {
		i-=interleavebytes;
		offset=SetFilePointer(input_file,-interleavebytes,0,FILE_CURRENT);
	}
	interleavereadpos=i/8*14;
	
	for (;i<interleavebytes;i+=8) {
		if (loopcount && offset+i+(NCH-1)*interleavebytes>=dsp.ea/(3-NCH)) {
			//DisplayError("loop");
			SetFilePointer(input_file,headersize+(dsp.sa&(~7))/(3-NCH),0,FILE_BEGIN);
			
			if (headertype!=type_mp2) { // MP2 has no info, we assume unchanged
				hist11=dsp.lyn1;
				hist12=dsp.lyn2;
		
				hist21=dsp2.lyn1;
				hist22=dsp2.lyn2;
			}

			interleavebufsize=i/8*14;

			loopcount--;
			if (!loopcount) fadecount=masterfadelength*SAMPLERATE;

			return;
		}
		ReadFile(input_file, &ADPCMbuf, 8, &l, NULL);
		decodebuffer(ADPCMbuf,interleave1+i/8*14,(ADPCMINFO*)dsp.coef,&hist11,&hist12);
		for (j=0;fadecount > 0 && j<14;j++) interleave1[i/8*14+j]*=((fadecount-j)/masterfadelength/SAMPLERATE);
		if (NCH==2) {
			SetFilePointer(input_file, interleavebytes-8, NULL, FILE_CURRENT);
			ReadFile(input_file, &ADPCMbuf, 8, &l, NULL);
			decodebuffer(ADPCMbuf,interleave2+i/8*14,(ADPCMINFO*)dsp2.coef,&hist21,&hist22);
			SetFilePointer(input_file, -interleavebytes, NULL, FILE_CURRENT);
			for (j=0;fadecount > 0 && j<14;j++) interleave2[i/8*14+j]*=((fadecount-j)/masterfadelength/SAMPLERATE);
		}
		if (fadecount >= 0) {
			fadecount-=14;
			if (fadecount < 0) fadecount=13;
		}
	}
	if (NCH==2) SetFilePointer(input_file,interleavebytes,NULL,FILE_CURRENT);
	interleavebufsize=i/8*14;
}


// render 576 samples into buf. 
// note that if you adjust the size of sample_buffer, for say, 1024
// sample blocks, it will still work, but some of the visualization 
// might not look as good as it could. Stick with 576 sample blocks
// if you can, and have an additional auxiliary (overflow) buffer if 
// necessary.. 

int get_576_samples(short *buf)
{
	int i;

	for (i=0;i<576;i++) {
		if (decode_pos_ms*SAMPLERATE/1000+i >= nrsamples) return i*NCH*(BPS/8);
		if (interleavereadpos >= interleavebufsize) fillinterleavebuffer();
		buf[i*NCH]=interleave1[interleavereadpos];
		if (NCH==2) buf[i*NCH+1]=interleave2[interleavereadpos];
		interleavereadpos++;
	}
	return 576*NCH*(BPS/8);
}


DWORD WINAPI __stdcall DecodeThread(void *b)
{
	int done=0;
	while (! *((int *)b) ) 
	{
		if (seek_needed != -1)
		{

			if (decode_pos_ms>seek_needed) {
					hist11=dsp.yn1;hist12=dsp.yn2;
					hist21=dsp2.yn1;hist22=dsp2.yn2;

					fadecount=-1;
	
					SetFilePointer(input_file, headersize, NULL, FILE_BEGIN);

					decode_pos_ms=0;
					
					if (dsp.loop_flag) loopcount=looptimes;
					else loopcount=0;

					fillinterleavebuffer();
			}
	
			while (decode_pos_ms<seek_needed) {
				get_576_samples((short*)sample_buffer);
				mod.outMod->Flush(decode_pos_ms);
				decode_pos_ms+=(576.0*1000.0)/(double)SAMPLERATE;
			}
			seek_needed=-1;
		}
		if (done)
		{
			mod.outMod->CanWrite();
			if (!mod.outMod->IsPlaying())
			{
				PostMessage(mod.hMainWindow,WM_WA_MPEG_EOF,0,0);
				return 0;
			}
			Sleep(10);
		}
		else if (mod.outMod->CanWrite() >= ((576*NCH*(BPS/8))<<(mod.dsp_isactive()?1:0)))
		{	
			int l=576*NCH*(BPS/8);
			l=get_576_samples((short*)sample_buffer);
			if (!l) 
			{
				done=1;
			}
			else
			{
				mod.SAAddPCMData((char *)sample_buffer,NCH,BPS,decode_pos_ms);
				mod.VSAAddPCMData((char *)sample_buffer,NCH,BPS,decode_pos_ms);
				decode_pos_ms+=(576.0*1000.0)/(double)SAMPLERATE;
				if (mod.dsp_isactive()) l=mod.dsp_dosamples((short *)sample_buffer,l/NCH/(BPS/8),BPS,NCH,SAMPLERATE)*(NCH*(BPS/8));
				mod.outMod->Write(sample_buffer,l);
			}
		}
		else Sleep(20);
	}
	return 0;
}


In_Module mod = 
{
	IN_VER,
	"Destop's DSP Player v1.3 improved version 11/09/05"
#ifdef _DEBUG
	" (DEBUG)"
#endif
	,
	0,	// hMainWindow
	0,  // hDllInstance
	"DSP\0DSP Audio File (*.DSP)\0GCM\0DSP Audio File (*.GCM)\0"
	,
	1,	// is_seekable
	1, // uses output
	config,
	about,
	init,
	quit,
	getfileinfo,
	infoDlg,
	isourfile,
	play,
	pause,
	unpause,
	ispaused,
	stop,
	
	getlength,
	getoutputtime,
	setoutputtime,

	setvolume,
	setpan,

	0,0,0,0,0,0,0,0,0, // vis stuff


	0,0, // dsp

	eq_set,

	NULL,		// setinfo

	0 // out_mod

};

__declspec( dllexport ) In_Module * winampGetInModule2()
{
	return &mod;
}

int main (void)
{
	return 0;
}
